// Siro: Selfmoved Label 19.05.2021

unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private

  public

  end;

Type TMyLabel = class(TLabel)
  private
    FMouseLeftDown : Boolean;
    FLastMouseX    : Integer;
    FLastMouseY    : Integer;
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp  (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(                      Shift: TShiftState; X, Y: Integer); override;
end;


var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TMyLabel.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then begin
    FMouseLeftDown:=TRUE;
    FLastMouseX := X;
    FLastMouseY := Y;
  end;
  inherited;
end;

procedure TMyLabel.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FMouseLeftDown:=FALSE;
  inherited;
end;

procedure TMyLabel.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  if (FLastMouseX = X) and (FLastMouseY = Y) then exit;

  if FMouseLeftDown then begin
    left:=left - FLastMouseX + X;
    top :=top  - FLastMouseY + Y;
  end;

  inherited;
end;

var MyLabel:TMyLabel;
procedure TForm1.FormCreate(Sender: TObject);
begin
  MyLabel:=TMyLabel.create(self);
  MyLabel.parent:=self;
  MyLabel.Caption:='SiroLabel';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(MyLabel) then MyLabel.free;
end;

end.

